#ifndef CORE_ERROR_SIMULATOR_HPP
#define CORE_ERROR_SIMULATOR_HPP

#include <stdexcept>

#ifdef ERROR_SIMULATOR
extern bool failTimeGet;
extern bool failThreadInit;
extern bool failThreadJoin;
extern bool failMutexInit;
extern bool failMutexLock;
extern bool failMutexUnlock;
extern int failStep;
extern int failStepThrow;
#define TIME_GET_FAIL failTimeGet
#define THREAD_INIT_FAIL failThreadInit
#define THREAD_JOIN_FAIL failThreadJoin
#define MUTEX_INIT_FAIL failMutexInit
#define MUTEX_LOCK_FAIL failMutexLock
#define MUTEX_UNLOCK_FAIL failMutexUnlock
#define FAIL_STEP (--failStep == 0)

inline void debugThrow() {
    if(--failStepThrow == 0) {
        throw std::runtime_error("not a real error");
    }
}

#define FAIL_STEP_THROW() debugThrow()
#else
#define TIME_GET_FAIL false
#define THREAD_INIT_FAIL false
#define THREAD_JOIN_FAIL false
#define MUTEX_INIT_FAIL false
#define MUTEX_LOCK_FAIL false
#define MUTEX_UNLOCK_FAIL false
#define FAIL_STEP false
#define FAIL_STEP_THROW() \
    do {                  \
    } while(false)
#endif

#endif
