#include "core/Vector.hpp"

void Core::setAngles(Vector3& v, float lengthAngle, float widthAngle) {
    float sWidth = 0.0f;
    float cWidth = 0.0f;
    sincosf(Core::degreeToRadian(widthAngle), &sWidth, &cWidth);

    float sLength = 0.0f;
    float cLength = 0.0f;
    sincosf(Core::degreeToRadian(lengthAngle), &sLength, &cLength);

    v[0] = cWidth * cLength;
    v[1] = sWidth;
    v[2] = -sLength * cWidth;
}

Core::Vector3 Core::cross(const Vector3& a, const Vector3& b) {
    return Vector3(
        a[1] * b[2] - a[2] * b[1], a[2] * b[0] - a[0] * b[2],
        a[0] * b[1] - a[1] * b[0]);
}
